//----------------------------------------------------------------------//
// ^Ǒ															//
//																		//
//----------------------------------------------------------------------//
#include <vcl.h>
#pragma hdrstop

#include <memory>
#include "UserFunc.h"
#include "Global.h"
#include "FindTag.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TFindTagForm *FindTagForm;

//---------------------------------------------------------------------------
__fastcall TFindTagForm::TFindTagForm(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TFindTagForm::FormCreate(TObject *Sender)
{
	HdrPanel->ClientHeight = get_FontHeight(ListFont, 4, 4);
	HdrPanel->Font->Assign(ListFont);
	HdrPanel->Color 	  = col_bgList;
	HdrPanel->Font->Color = col_fgList;

	TagList    = new TStringList();
	ResListBuf = new TStringList();

	ListScrPanel = new UsrScrollPanel(ListPanel,  ResListBox, USCRPNL_FLAG_P_WP | USCRPNL_FLAG_L_WP);
}
//---------------------------------------------------------------------------
void __fastcall TFindTagForm::FormShow(TObject *Sender)
{
	IniFile->LoadPosInfo(this, DialogCenter);

	TListBox *lp = ResListBox;
	set_StdListBox(lp, LBTAG_OPT_LCPY);
	set_UsrScrPanel(ListScrPanel);

	TagList->Clear();
	std::unique_ptr<TStringList> fbuf(new TStringList());
	if (load_text_ex(TagFile, fbuf.get())!=0) {
		fbuf->Sort();
		UnicodeString lst_tag;
		UnicodeString rnam = ExtractFilePath(TagFile);
		for (int i=0; i<fbuf->Count; i++) {
			UnicodeString lbuf = fbuf->Strings[i];
			if (StartsStr("!", lbuf)) continue;
			if (!FileName.IsEmpty() && !SameText(FileName, rel_to_absdir(get_tkn(get_tkn_r(lbuf, '\t'), '\t'), rnam))) continue;

			UnicodeString tnam = get_tkn(lbuf, "\t");
			if (!SameStr(lst_tag, tnam)) {
				TagList->Add(tnam);
				lst_tag = tnam;
			}
		}

		if (!FileName.IsEmpty()) UpdateList();
	}

	UnicodeString tit = "^O";
	if (!FileName.IsEmpty()) tit.cat_sprintf(_T(" - %s"), ExtractFileName(FileName));
	Caption = tit;

	HdrPanel->Caption = TagName = IncSeaWord = EmptyStr;
}
//---------------------------------------------------------------------------
void __fastcall TFindTagForm::FormClose(TObject *Sender, TCloseAction &Action)
{
	ResListBuf->Clear();
	ResListBox->Count = 0;

	IniFile->SavePosInfo(this);
}
//---------------------------------------------------------------------------
void __fastcall TFindTagForm::FormDestroy(TObject *Sender)
{
	delete TagList;
	delete ResListBuf;
	delete ListScrPanel;
}

//---------------------------------------------------------------------------
void __fastcall TFindTagForm::UpdateList()
{
	HdrPanel->Caption = IncSeaWord;

	ResListBuf->Clear();
	if (!IncSeaWord.IsEmpty()) {
		for (int i=0; i<TagList->Count; i++) {
			UnicodeString lbuf = TagList->Strings[i];
			if (ContainsText(lbuf, IncSeaWord)) ResListBuf->Add(lbuf);
		}
	}
	else if (!FileName.IsEmpty()) {
		ResListBuf->Assign(TagList);
	}

	//Xg{bNXɊ蓖(z)
	ResListBox->Count = ResListBuf->Count;
	if (ResListBox->Count>0) ResListBox->ItemIndex = 0;
	ResListBox->SetFocus();
	ListScrPanel->UpdateKnob();
}

//---------------------------------------------------------------------------
//ꗗ̕`
//---------------------------------------------------------------------------
void __fastcall TFindTagForm::ResListBoxDrawItem(TWinControl *Control, int Index,
          TRect &Rect, TOwnerDrawState State)
{
	TListBox *lp = (TListBox *)Control;
	TCanvas  *cv = lp->Canvas;

	cv->Font->Assign(ListFont);
	cv->Brush->Color = State.Contains(odSelected)? col_selItem : col_bgList;
	cv->FillRect(Rect);

	int xp = Rect.Left + 4;
	cv->Font->Color = (State.Contains(odSelected) && col_fgSelItem!=clNone)? col_fgSelItem : col_fgList;
	cv->TextOut(xp, Rect.Top + 2, lp->Items->Strings[Index]);

	//J[\
	draw_ListCursor(lp, Rect, Index, State);
}
//---------------------------------------------------------------------------
void __fastcall TFindTagForm::ResListBoxData(TWinControl *Control, int Index, UnicodeString &Data)
{
	Data = (Index>=0 && Index<ResListBuf->Count)? ResListBuf->Strings[Index] : EmptyStr;
}

//---------------------------------------------------------------------------
//m
//---------------------------------------------------------------------------
void __fastcall TFindTagForm::ResListBoxDblClick(TObject *Sender)
{
	int idx = ResListBox->ItemIndex;
	if (idx!=-1) TagName = ResListBox->Items->Strings[idx];
	ModalResult = !TagName.IsEmpty()? mrOk : mrCancel;
}

//---------------------------------------------------------------------------
//ꗗł̃L[
//---------------------------------------------------------------------------
void __fastcall TFindTagForm::ResListBoxKeyDown(TObject *Sender, WORD &Key, TShiftState Shift)
{
	UnicodeString KeyStr = get_KeyStr(Key, Shift);		if (KeyStr.IsEmpty()) return;
	UnicodeString cmd_F  = Key_to_CmdF(KeyStr);
	UnicodeString cmd_V  = Key_to_CmdV(KeyStr);
	UnicodeString cmd_S  = KeyFuncList->Values["S:" + KeyStr];

	TListBox *lp = (TListBox*)Sender;
	if (equal_ENTER(KeyStr))
		ResListBoxDblClick(Sender);
	else if (equal_ESC(KeyStr))
		ModalResult = mrCancel;
	else if (update_IncSeaWord(IncSeaWord, KeyStr))
		UpdateList();
	else if (USAME_TI(cmd_S, "ClearIncKeyword")) {
		IncSeaWord = EmptyStr;
		UpdateList();
	}
	else if (USAME_TI(cmd_F, "TextViewer")) {
		TagCmd = "VIEW";
		ResListBoxDblClick(Sender);
	}
	else if (USAME_TI(cmd_F, "FileEdit")) {
		TagCmd = "EDIT";
		ResListBoxDblClick(Sender);
	}
	else if (ExeCmdListBox(lp, cmd_F) || ExeCmdListBox(lp, cmd_V)) {
		if (USAME_TI(cmd_V, "ClipCopy")) {
			TagCmd = "COPY";
			ModalResult = mrOk;
		}
	}
	else if (USAME_TI(cmd_S, "IncSearchUp"))	ListBoxCursorUp(lp);
	else if (USAME_TI(cmd_S, "IncSearchDown"))	ListBoxCursorDown(lp);
	else if (MovListBoxFromFilter(lp, KeyStr))	;
}
//---------------------------------------------------------------------------
void __fastcall TFindTagForm::ResListBoxKeyPress(TObject *Sender, System::WideChar &Key)
{
	//CN^T[`
	if (_istalnum(Key) || Key==VK_SPACE || Key==VK_RETURN) Key = 0;
}

//---------------------------------------------------------------------------
//rA[Ń_CNg^OWv
//---------------------------------------------------------------------------
void __fastcall TFindTagForm::TagViewActionExecute(TObject *Sender)
{
	TagCmd = "VIEW";
	ResListBoxDblClick(Sender);
}
//---------------------------------------------------------------------------
//GfB^Ń_CNg^OWv
//---------------------------------------------------------------------------
void __fastcall TFindTagForm::TagJumpActionExecute(TObject *Sender)
{
	TagCmd = "EDIT";
	ResListBoxDblClick(Sender);
}
//---------------------------------------------------------------------------
//̃^ORs[
//---------------------------------------------------------------------------
void __fastcall TFindTagForm::CopyTagActionExecute(TObject *Sender)
{
	TListBox *lp = ResListBox;
	if (lp->ItemIndex!=-1) copy_to_Clipboard(lp->Items->Strings[lp->ItemIndex]);

	TagCmd = "COPY";
	ModalResult = mrOk;
}
//---------------------------------------------------------------------------
void __fastcall TFindTagForm::PopupItemUpdate(TObject *Sender)
{
	((TAction*)Sender)->Enabled = (ResListBox->ItemIndex!=-1);
}

//---------------------------------------------------------------------------
void __fastcall TFindTagForm::FormKeyDown(TObject *Sender, WORD &Key, TShiftState Shift)
{
	SpecialKeyProc(this, Key, Shift);
}
//---------------------------------------------------------------------------
