//----------------------------------------------------------------------//
// 񑀍															//
//																		//
//----------------------------------------------------------------------//
#include <vcl.h>
#pragma hdrstop
#include <tchar.h>
#include <algorithm>
#include <memory>
#include <System.StrUtils.hpp>
#include <System.Masks.hpp>
#include <RegularExpressions.hpp>
#include "usr_str.h"

//---------------------------------------------------------------------------
_TCHAR *null_TCHAR = _T("");

UnicodeString	KeyStr_Shift = "Shift+";
UnicodeString	KeyStr_Ctrl  = "Ctrl+";
UnicodeString	KeyStr_Alt	 = "Alt+";

//---------------------------------------------------------------------------
//R\[gɑΉr
//---------------------------------------------------------------------------
int __fastcall comp_NaturalOrder(TStringList *List, int Index1, int Index2)
{
	return StrCmpLogicalW(List->Strings[Index1].c_str(), List->Strings[Index2].c_str());
}

//---------------------------------------------------------------------------
//R  (J}Ή/ ꍇ Objects Ŕr)
//---------------------------------------------------------------------------
int __fastcall comp_AscendOrder(TStringList *List, int Index1, int Index2)
{
	UnicodeString s1  = List->Strings[Index1];
	UnicodeString s2  = List->Strings[Index2];
	UnicodeString ns1 = extract_top_int_str(s1);
	UnicodeString ns2 = extract_top_int_str(s2);

	int res = (!ns1.IsEmpty() && !ns2.IsEmpty())? StrCmpLogicalW(ns1.c_str(), ns2.c_str()) : 0;
	if (res==0) res = StrCmpLogicalW(s1.c_str(), s2.c_str());
	if (res==0) res = (int)List->Objects[Index1] - (int)List->Objects[Index2];
	return res;
}
//---------------------------------------------------------------------------
//R~  (J}Ή/ ꍇ Objects Ŕr)
//---------------------------------------------------------------------------
int __fastcall comp_DescendOrder(TStringList *List, int Index1, int Index2)
{
	UnicodeString s1  = List->Strings[Index1];
	UnicodeString s2  = List->Strings[Index2];
	UnicodeString ns1 = extract_top_int_str(s1);
	UnicodeString ns2 = extract_top_int_str(s2);

	int res = (!ns1.IsEmpty() && !ns2.IsEmpty())? StrCmpLogicalW(ns2.c_str(), ns1.c_str()) : 0;
	if (res==0) res = StrCmpLogicalW(s2.c_str(), s1.c_str());
	if (res==0) res = (int)List->Objects[Index2] - (int)List->Objects[Index1];
	return res;
}
//---------------------------------------------------------------------------
// Objects
//---------------------------------------------------------------------------
int __fastcall comp_ObjectsOrder(TStringList *List, int Index1, int Index2)
{
	return (int)List->Objects[Index1] - (int)List->Objects[Index2];
}

//---------------------------------------------------------------------------
//CSVpr֐
//---------------------------------------------------------------------------
int  USR_CsvCol 	 = 0;		//\[gΏۗ
int  USR_CsvSortMode = 1;		//\[g[h 1:/ -1~
bool USR_CsvTopIsHdr = false;	//擪s͍ږ

//---------------------------------------------------------------------------
//CSV R (ꍇ Objects Ŕr)
//---------------------------------------------------------------------------
int __fastcall comp_CsvNaturalOrder(TStringList *List, int Index1, int Index2)
{
	if (USR_CsvTopIsHdr) {	//擪s͍ږ
		if ((int)List->Objects[Index1]==0) return -1;
		if ((int)List->Objects[Index2]==0) return  1;
	}

	UnicodeString s1  = get_csv_item(List->Strings[Index1], USR_CsvCol);
	UnicodeString s2  = get_csv_item(List->Strings[Index2], USR_CsvCol);
	UnicodeString ns1 = extract_top_int_str(s1);
	UnicodeString ns2 = extract_top_int_str(s2);

	int res = (!ns1.IsEmpty() && !ns2.IsEmpty())? StrCmpLogicalW(ns1.c_str(), ns2.c_str()) : 0;
	if (res==0) res = StrCmpLogicalW(s1.c_str(), s2.c_str());
	if (res==0) res = (int)List->Objects[Index1] - (int)List->Objects[Index2];
	res *= USR_CsvSortMode;
	return res;
}
//---------------------------------------------------------------------------
//TSV R (ꍇ Objects Ŕr)
//---------------------------------------------------------------------------
int __fastcall comp_TsvNaturalOrder(TStringList *List, int Index1, int Index2)
{
	if (USR_CsvTopIsHdr) {	//擪s͍ږ
		if ((int)List->Objects[Index1]==0) return -1;
		if ((int)List->Objects[Index2]==0) return  1;
	}

	TStringDynArray itm1 = SplitString(List->Strings[Index1], "\t");
	TStringDynArray itm2 = SplitString(List->Strings[Index2], "\t");
	UnicodeString s1  = (USR_CsvCol<itm1.Length)? itm1[USR_CsvCol] : EmptyStr;
	UnicodeString s2  = (USR_CsvCol<itm1.Length)? itm2[USR_CsvCol] : EmptyStr;
	UnicodeString ns1 = extract_top_int_str(s1);
	UnicodeString ns2 = extract_top_int_str(s2);

	int res = (!ns1.IsEmpty() && !ns2.IsEmpty())? StrCmpLogicalW(ns1.c_str(), ns2.c_str()) : 0;
	if (res==0) res = StrCmpLogicalW(s1.c_str(), s2.c_str());
	if (res==0) res = (int)List->Objects[Index1] - (int)List->Objects[Index2];
	res *= USR_CsvSortMode;
	return res;
}

//---------------------------------------------------------------------------
//wZp[^̑O̕擾
//  Zp[^Ȃꍇ́Â܂ܕԂ
//---------------------------------------------------------------------------
UnicodeString get_tkn(UnicodeString s, UnicodeString sp)
{
	int p = s.Pos(sp);
	return (p==0)? s : s.SubString(1, p - 1);
}
//---------------------------------------------------------------------------
UnicodeString get_tkn(UnicodeString s, _TCHAR *sp)
{
	int p = s.Pos(sp);
	return (p==0)? s : s.SubString(1, p - 1);
}
//---------------------------------------------------------------------------
UnicodeString get_tkn(UnicodeString s, WideChar sp)
{
	int p = s.Pos(sp);
	return (p==0)? s : s.SubString(1, p - 1);
}

//---------------------------------------------------------------------------
//wZp[^̌̕擾
//  Zp[^Ȃꍇ́AEmptyStr Ԃ
//---------------------------------------------------------------------------
UnicodeString get_tkn_r(UnicodeString s, UnicodeString sp)
{
	int p = s.Pos(sp);
	return (p==0)? EmptyStr : s.SubString(p + sp.Length(),  s.Length() - (p - sp.Length() + 1));
}
//---------------------------------------------------------------------------
UnicodeString get_tkn_r(UnicodeString s, _TCHAR *sp)
{
	int p = s.Pos(sp);
	return (p==0)? EmptyStr : s.SubString(p + _tcslen(sp),  s.Length() - (p - _tcslen(sp) + 1));
}
//---------------------------------------------------------------------------
UnicodeString get_tkn_r(UnicodeString s, WideChar sp)
{
	int p = s.Pos(sp);
	return (p==0)? EmptyStr : s.SubString(p + 1,  s.Length() - p);
}

//---------------------------------------------------------------------------
//wZp[^Ԃ̕擾
//  Zp[^Ȃꍇ́AOZp[^ȍ~̕Ԃ
//---------------------------------------------------------------------------
UnicodeString get_tkn_m(UnicodeString s, _TCHAR *sp1, _TCHAR *sp2)
{
	return get_tkn(get_tkn_r(s, sp1), sp2);
}
//---------------------------------------------------------------------------
UnicodeString get_tkn_m(UnicodeString s, WideChar sp1, WideChar sp2)
{
	return get_tkn(get_tkn_r(s, sp1), sp2);
}

//---------------------------------------------------------------------------
//^ȗO̕擾
//  ^uȂꍇ́Â܂ܕԂ
//---------------------------------------------------------------------------
UnicodeString get_pre_tab(UnicodeString s)
{
	return get_tkn(s, '\t');
}
//---------------------------------------------------------------------------
//^ǔ̕擾
//  ^uȂꍇ́AEmptyStr Ԃ
//---------------------------------------------------------------------------
UnicodeString get_post_tab(UnicodeString s)
{
	return get_tkn_r(s, '\t');
}

//---------------------------------------------------------------------------
//񒆂 (`) 擾
//---------------------------------------------------------------------------
UnicodeString get_in_paren(UnicodeString s)
{
	int p1 = s.Pos('(');
	int p2 = s.Pos(')');
	if (p1==0 || p2==0 || p1>=p2) return EmptyStr;
	return s.SubString(p1 + 1,  p2 - p1 - 1);
}
//---------------------------------------------------------------------------
//񒆂 (`) 擾A (`) ̌㑱
//---------------------------------------------------------------------------
UnicodeString split_in_paren(UnicodeString &s)
{
	return get_tkn_r(split_tkn(s, ')'), '(');
}

//---------------------------------------------------------------------------
//OɃ^u܂܂Ȃ擾
//  s̏ꍇAłȂŏ̕
//---------------------------------------------------------------------------
UnicodeString get_norm_str(UnicodeString s)
{
	UnicodeString ret_str;
	std::unique_ptr<TStringList> lst(new TStringList());
	lst->Text = s;
	for (int i=0; i<lst->Count; i++) {
		ret_str = lst->Strings[i];
		ret_str = replace_regex(ret_str, _T("^\\t+"), null_TCHAR);
		ret_str = replace_regex(ret_str, _T("\\t+$"), null_TCHAR);
		if (!ret_str.IsEmpty()) break;
	}
	return ret_str;
}

//---------------------------------------------------------------------------
//wZp[^O̕𕪗Ď擾
//  Zp[^Ȃꍇ́Â܂ܕԂA͋
//---------------------------------------------------------------------------
UnicodeString split_tkn(UnicodeString &s, UnicodeString sp)
{
	UnicodeString r;
	int p = s.Pos(sp);
	if (p==0) {
		r = s;
		s = EmptyStr;
	}
	else {
		r = s.SubString(1, p - 1);
		s = s.SubString(p + sp.Length(), s.Length() - (p - sp.Length() + 1));
	}
	return r;
}
//---------------------------------------------------------------------------
UnicodeString split_tkn(UnicodeString &s, _TCHAR *sp)
{
	return split_tkn(s, UnicodeString(sp));
}
//---------------------------------------------------------------------------
UnicodeString split_tkn(UnicodeString &s, WideChar sp)
{
	UnicodeString r;
	int p = s.Pos(sp);
	if (p==0) {
		r = s;
		s = EmptyStr;
	}
	else {
		r = s.SubString(1, p - 1);
		s = s.SubString(p + 1, s.Length() - p);
	}
	return r;
}

//---------------------------------------------------------------------------
//^uO̕𕪗Ď擾
//  ^uȂꍇ́Â܂ܕԂA͋
//---------------------------------------------------------------------------
UnicodeString split_pre_tab(UnicodeString &s)
{
	return split_tkn(s, '\t');
}

//---------------------------------------------------------------------------
//񂩂(^:`:)𕪗擾
//---------------------------------------------------------------------------
UnicodeString split_dsc(UnicodeString &s)
{
	UnicodeString dsc;
	if (!StartsStr("::{", s) && StartsStr(":", s)) {
		s.Delete(1, 1);
		dsc = split_tkn(s, ':');
		s = Trim(s);
	}
	return dsc;
}

//---------------------------------------------------------------------------
//񂩂擪𕪗擾
//---------------------------------------------------------------------------
UnicodeString split_top_ch(UnicodeString &s)
{
	UnicodeString c;
	if (!s.IsEmpty()) {
		c = s.SubString(1, 1);
		s.Delete(1, 1);
	}
	return c;
}
//---------------------------------------------------------------------------
WideChar split_top_wch(UnicodeString &s)
{
	WideChar c = '\0';
	if (!s.IsEmpty()) {
		c = s[1];
		s.Delete(1, 1);
	}
	return c;
}

//---------------------------------------------------------------------------
//R}hCt@C𕪗
//---------------------------------------------------------------------------
UnicodeString split_file_param(UnicodeString &s)
{
	UnicodeString ret_str;
	s = Trim(s);
	if (remove_top_s(s, '\"')) {
		ret_str = split_tkn(s, '\"');
		s = Trim(s);
	}
	else
		ret_str = split_tkn(s, ' ');
	return ret_str;
}

//---------------------------------------------------------------------------
//w؂ŕ
//---------------------------------------------------------------------------
TStringDynArray split_strings_tab(UnicodeString s)
{
	return SplitString(s, "\t");
}
//---------------------------------------------------------------------------
TStringDynArray split_strings_semicolon(UnicodeString s)
{
	return SplitString(s, ";");
}

//---------------------------------------------------------------------------
//񂩂w폜
//  ߂l: ture=폜/ false=ꂪ܂܂ĂȂ
//---------------------------------------------------------------------------
bool remove_text(UnicodeString &s, UnicodeString w)
{
	if (ContainsText(s, w)) {
		s = ReplaceText(s, w, EmptyStr);
		return true;
	}
	else
		return false;
}
//---------------------------------------------------------------------------
bool remove_text(UnicodeString &s, _TCHAR *w)
{
	return remove_text(s, UnicodeString(w));
}

//---------------------------------------------------------------------------
//̐擪Ɏwꂪ폜 (召𖳎)
//  ߂l: ture=폜/ false=擪ɌꂪȂ
//---------------------------------------------------------------------------
bool remove_top_text(UnicodeString &s, UnicodeString w)
{
	if (!StartsText(w, s)) return false;
	s.Delete(1, w.Length());
	return true;
}
//---------------------------------------------------------------------------
bool remove_top_text(UnicodeString &s, _TCHAR *w)
{
	return remove_top_text(s, UnicodeString(w));
}

//---------------------------------------------------------------------------
//̐擪Ɏwꂪ폜 (召)
//  ߂l:  ture=폜/ false=擪ɌꂪȂ
//---------------------------------------------------------------------------
bool remove_top_s(UnicodeString &s, UnicodeString w)
{
	if (!StartsStr(w, s)) return false;
	s.Delete(1, w.Length());
	return true;
}
//---------------------------------------------------------------------------
bool remove_top_s(UnicodeString &s, _TCHAR *w)
{
	if (!StartsStr(w, s)) return false;
	s.Delete(1, _tcslen(w));
	return true;
}
//---------------------------------------------------------------------------
bool remove_top_s(UnicodeString &s, WideChar w)
{
	if (!StartsStr(w, s)) return false;
	s.Delete(1, 1);
	return true;
}

//---------------------------------------------------------------------------
//̐擪 @ 폜
//  ߂l: ture=擪 @ 폜
//---------------------------------------------------------------------------
bool remove_top_AT(UnicodeString &s)
{
	return remove_top_s(s, '@');
}
//---------------------------------------------------------------------------
//̐擪 $ 폜
//  ߂l: ture=擪 $ 폜
//---------------------------------------------------------------------------
bool remove_top_Dollar(UnicodeString &s)
{
	return remove_top_s(s, '$');
}

//---------------------------------------------------------------------------
//̖Ɏwꂪ폜 (召𖳎)
//  ߂l: ture=폜
//---------------------------------------------------------------------------
bool remove_end_text(UnicodeString &s, UnicodeString w)
{
	if (!EndsText(w, s)) return false;
	s.Delete(s.Length() - w.Length() + 1, w.Length());
	return true;
}
//---------------------------------------------------------------------------
//̖Ɏwꂪ폜 (召)
//  ߂l: ture=폜
//---------------------------------------------------------------------------
bool remove_end_s(UnicodeString &s, UnicodeString w)
{
	if (!EndsStr(w, s)) return false;
	s.Delete(s.Length() - w.Length() + 1, w.Length());
	return true;
}
//---------------------------------------------------------------------------
bool remove_end_s(UnicodeString &s, WideChar w)
{
	if (!EndsStr(w, s)) return false;
	s.Delete(s.Length(), 1);
	return true;
}

//---------------------------------------------------------------------------
void delete_end(UnicodeString &s)
{
	s.Delete(s.Length(), 1);
}

//---------------------------------------------------------------------------
//擪O擾
//---------------------------------------------------------------------------
UnicodeString exclude_top(UnicodeString s)
{
	return s.SubString(2, s.Length() - 1);
}
//---------------------------------------------------------------------------
//擪ƖO擾
//---------------------------------------------------------------------------
UnicodeString exclude_top_end(UnicodeString s)
{
	return s.SubString(2, s.Length() - 2);
}

//---------------------------------------------------------------------------
//̒u
//---------------------------------------------------------------------------
UnicodeString replace_i(UnicodeString s, _TCHAR *o, _TCHAR *r)
{
	return ReplaceText(s, o, r);
}
//---------------------------------------------------------------------------
UnicodeString replace_s(UnicodeString s, _TCHAR *o, _TCHAR *r)
{
	return ReplaceStr(s, o, r);
}

//---------------------------------------------------------------------------
//K\ɂu
//---------------------------------------------------------------------------
UnicodeString replace_regex(UnicodeString s, _TCHAR *o, _TCHAR *r)
{
	return TRegEx::Replace(s, o, r);
}

//---------------------------------------------------------------------------
//Xgɂĕu
//  Xg:  TAB u
//---------------------------------------------------------------------------
UnicodeString replace_str_by_list(UnicodeString s, TStringList *lst)
{
	for (int i=0; i<lst->Count; i++) {
		UnicodeString t_s = lst->Strings[i];
		UnicodeString f_s = split_pre_tab(t_s);
		s = ReplaceStr(s, f_s, t_s);
	}
	return s;
}

//---------------------------------------------------------------------------
//𖖔ɒǉ̂擾
//---------------------------------------------------------------------------
UnicodeString append_str(UnicodeString s, _TCHAR *t)
{
	return s + UnicodeString(t);
}

//---------------------------------------------------------------------------
//w蒷ɂȂ܂Ő擪ɋ󔒂}
//---------------------------------------------------------------------------
UnicodeString ins_spc_length(UnicodeString s, int len)
{
	int n = len - s.Length();
	if (n>0) s.Insert(StringOfChar(_T(' '), n), 1);
	return s;
}

//---------------------------------------------------------------------------
//񂪋ȂftHgݒ
//---------------------------------------------------------------------------
void set_if_empty(UnicodeString &s, UnicodeString def)
{
	if (s.IsEmpty()) s = def;
}
//---------------------------------------------------------------------------
void set_if_empty(UnicodeString &s, _TCHAR *def)
{
	if (s.IsEmpty()) s = def;
}

//---------------------------------------------------------------------------
//񂪋ȂftHg擾
//---------------------------------------------------------------------------
UnicodeString def_if_empty(UnicodeString s, UnicodeString def)
{
	return s.IsEmpty()? def : s;
}
//---------------------------------------------------------------------------
UnicodeString def_if_empty(UnicodeString s, _TCHAR *def)
{
	return s.IsEmpty()? UnicodeString(def) : s;
}

//---------------------------------------------------------------------------
//񂩂琮l𒊏o
//sO𑗏o
//---------------------------------------------------------------------------
int extract_int(UnicodeString s)
{
	int i = 1;
	while (i<=s.Length()) if (!iswdigit(s[i])) s.Delete(i, 1); else i++;
	return s.ToInt();
}
//---------------------------------------------------------------------------
//񂩂琮l𒊏o
//̏ꍇ̓ftHglԂ
//---------------------------------------------------------------------------
int extract_int_def(UnicodeString s, int def)
{
	int i = 1;
	while (i<=s.Length()) if (!iswdigit(s[i])) s.Delete(i, 1); else i++;
	return s.ToIntDef(def);
}

//---------------------------------------------------------------------------
//̐擪琔l擾(J}͖)
//---------------------------------------------------------------------------
UnicodeString extract_top_int_str(UnicodeString s)
{
	UnicodeString ret_str;
	s = Trim(s);
	for (int i=1; i<=s.Length(); i++) {
		WideChar c = s[i];
		if (c==',') {
			if (i==1) break;
		}
		else if (iswdigit(c)) ret_str.cat_sprintf(_T("%c"), c);
		else break;
	}
	return ret_str;
}

//---------------------------------------------------------------------------
//召ʂɕ
//---------------------------------------------------------------------------
int pos_i(
	UnicodeString wd,	//
	UnicodeString s)	//Ώە
{
	if (wd.IsEmpty()) return 0;
	return s.UpperCase().Pos(wd.UpperCase());
}
//---------------------------------------------------------------------------
int pos_i(_TCHAR *wd, UnicodeString s)
{
	return pos_i(UnicodeString(wd), s);
}

//---------------------------------------------------------------------------
//񂪍ŌɌʒu擾
//---------------------------------------------------------------------------
int pos_r(
	UnicodeString wd,	//
	UnicodeString s)	//Ώە
{
	if (wd.IsEmpty()) return 0;

	int p  = 0;
	int p0 = 1;
	for (;;) {
		int p1 = PosEx(wd, s, p0);
		if (p1==0) break;
		p  = p1;
		p0 = p + 1;
	}

	return p;
}
//---------------------------------------------------------------------------
int pos_r(_TCHAR *wd, UnicodeString s)
{
	return pos_r(UnicodeString(wd), s);
}

//---------------------------------------------------------------------------
//召ʂɕ񂪍ŌɌʒu擾
//---------------------------------------------------------------------------
int pos_r_i(
	UnicodeString wd,	//
	UnicodeString s)	//Ώە
{
	if (wd.IsEmpty()) return 0;

	UnicodeString ss = s;
	int p = 0;
	for (;;) {
		int p1 = pos_i(wd, ss);
		if (p1==0) break;
		ss.Delete(1, p1);
		p += p1;
	}

	return p;
}

//---------------------------------------------------------------------------
//pOŁA񂪍ŌɌʒu擾
//---------------------------------------------------------------------------
int pos_r_q(
	UnicodeString wd,	//( \v ͏)
	UnicodeString s)	//Ώە
{
	if (wd.IsEmpty()) return 0;
	UnicodeString ss;
	bool q_flag = false;
	for (int i=1; i<=s.Length(); i++) {
		WideChar c = s[i];
		//pO
		if (!q_flag) {
			if (c=='\"') q_flag = true;
		}
		//p
		else {
			if (c=='\"')
				q_flag = false;
			else
				c = '\v';
		}
		ss += c;
	}
	return pos_r(wd, ss);
}

//---------------------------------------------------------------------------
//pOŁA: ŌɌʒu擾 (:\\ ͏)
//---------------------------------------------------------------------------
int pos_r_q_colon(UnicodeString s)
{
	return pos_r_q(":", REPLACE_TS(s, ":\\", "\f\f"));
}

//---------------------------------------------------------------------------
bool contains_i(UnicodeString s, _TCHAR *w)
{
	return ContainsText(s, w);
}
//---------------------------------------------------------------------------
bool contains_i(UnicodeString s, WideChar w)
{
	return ContainsText(s, w);
}
//---------------------------------------------------------------------------
bool contains_s(UnicodeString s, _TCHAR *w)
{
	return ContainsStr(s, w);
}
//---------------------------------------------------------------------------
bool contains_s(UnicodeString s, WideChar w)
{
	return ContainsStr(s, w);
}

//---------------------------------------------------------------------------
// | ؂胊XgɎwꂪ܂܂Ă邩H
//---------------------------------------------------------------------------
bool contained_wd_i(UnicodeString lst, UnicodeString wd)
{
	if (wd.IsEmpty()) return false;

	if (!StartsStr("|", lst)) lst.Insert("|" ,1);
	if (!EndsStr("|", lst))   lst.UCAT_T("|");
	return ContainsText(lst, "|" + wd + "|");
}
//---------------------------------------------------------------------------
bool contained_wd_i(_TCHAR *lst, UnicodeString wd)
{
	return contained_wd_i(UnicodeString(lst), wd);
}

//---------------------------------------------------------------------------
// | ؂胊Xǧ܂ł邩H
//---------------------------------------------------------------------------
bool contains_wd_i(UnicodeString s, _TCHAR *lst)
{
	TStringDynArray w_lst = SplitString(lst, "|");
	for (int i=0; i<w_lst.Length; i++) if (ContainsText(s, w_lst[i])) return true;
	return false;
}

//---------------------------------------------------------------------------
// | ؂胊XgwCfbNX̌擾
//---------------------------------------------------------------------------
UnicodeString get_word_i_idx(_TCHAR *lst, int idx)
{
	TStringDynArray w_lst = SplitString(lst, "|");
	return (idx>=0 && idx<w_lst.Length)? w_lst[idx] : EmptyStr;
}
//---------------------------------------------------------------------------
// | ؂胊Xgw̃CfbNX擾
//---------------------------------------------------------------------------
int idx_of_word_i(_TCHAR *lst, UnicodeString wd)
{
	TStringDynArray w_lst = SplitString(lst, "|");
	int idx = -1;
	for (int i=0; i<w_lst.Length && idx==-1; i++) if (SameText(w_lst[i], wd)) idx = i;
	return idx;
}

//---------------------------------------------------------------------------
//ChJ[h܂ރp^[ɂ镶v
//---------------------------------------------------------------------------
bool str_match(UnicodeString ptn, UnicodeString s)
{
	UnicodeString c = ptn.SubString(1, 1);
	UnicodeString next_str = s.SubString(2, s.Length() - 1);
	UnicodeString next_ptn = ptn.SubString(2, ptn.Length() - 1);

	if (c.IsEmpty())
		return s.IsEmpty();
	else if (SameStr(c, "*"))
		return str_match(next_ptn, s) || (!s.IsEmpty() && str_match(ptn, next_str));
	else if (SameStr(c, "?"))
		return !s.IsEmpty() && str_match(next_ptn, next_str);
	else {
		return (CompareText(c, s.SubString(1, 1))==0) && str_match(next_ptn, next_str);
	}
}

//---------------------------------------------------------------------------
//K\p^[̃`FbN
//---------------------------------------------------------------------------
bool chk_RegExPtn(UnicodeString ptn)
{
	if (ptn.IsEmpty()) return false;

	try {
		TRegEx x(ptn, TRegExOptions() << roCompiled);
		return true;
	}
	catch (...) {
		return false;
	}
}
//---------------------------------------------------------------------------
//K\ɂ}b`
//---------------------------------------------------------------------------
bool is_match_regex(UnicodeString s, _TCHAR *ptn)
{
	return TRegEx::IsMatch(s, ptn);
}

//---------------------------------------------------------------------------
//Ɏw(܂̓p^[)܂܂Ă邩H
//  ߂l: }b`̕
//---------------------------------------------------------------------------
UnicodeString ptn_match_str(
	UnicodeString ptn,	//L[[h (;ŋ؂ĕw)
						//  /`/ Ȃ琳K\p^[
	UnicodeString s)	//Ώە
{
	TStringDynArray p_lst = SplitString(ptn, ";");
	TRegExOptions opt; opt << roIgnoreCase;
	try {
		UnicodeString ret_str;
		for (int i=0; i<p_lst.Length && ret_str.IsEmpty(); i++) {
			UnicodeString kwd = p_lst[i];
			//K\
			if (is_regex_slash(kwd)) {
				TMatch mt = TRegEx::Match(s, exclude_top_end(kwd), opt);
				ret_str = mt.Success? mt.Value : EmptyStr;
			}
			//ʏ
			else {
				int p = pos_i(kwd, s);
				ret_str = (p>0)? s.SubString(p, kwd.Length()) : EmptyStr;
			}
		}
		return ret_str;
	}
	catch (...) {
		return EmptyStr;
	}
}

//---------------------------------------------------------------------------
//ꃊXg쐬
//---------------------------------------------------------------------------
void get_find_wd_list(UnicodeString wd, TStringList *lst)
{
	for (;;) {
		if (wd.IsEmpty()) break;
		int ph = wd.Pos(" ");
		int pw = wd.Pos("@");
		int p = (ph && !pw)? ph : (!ph && pw)? pw : (ph && pw)? std::min(ph, pw) : 0;
		if (p==1)
			wd.Delete(1, 1);
		else if (p>1) {
			lst->Add(wd.SubString(1, p - 1));
			wd.Delete(1, p);
		}
		else {
			lst->Add(wd); break;
		}
	}

	//󔒂^uϊ
	for (int i=0; i<lst->Count; i++) lst->Strings[i] = conv_esc_char(lst->Strings[i]);
}

//---------------------------------------------------------------------------
//̕ OR/AND 
//---------------------------------------------------------------------------
bool find_mlt(
	UnicodeString wd,	// (̏ꍇ͔p܂͑Sp󔒂ŋ؂j
	UnicodeString s,	//Ώە
	bool and_sw,		//AND			(default = false)
	bool not_sw,		//NOT			(default = false)
	bool case_sw)		//召	(default = false)
{
	if (wd.IsEmpty()) return false;

	//ꃊXg쐬
	std::unique_ptr<TStringList> wlst(new TStringList());
	get_find_wd_list(wd, wlst.get());

	//
	bool ret = and_sw;
	for (int i=0; i<wlst->Count; i++) {
		int p = case_sw? s.Pos(wlst->Strings[i]) : pos_i(wlst->Strings[i], s);
		if (!not_sw) {
			//܂
			if (p>0) {
				//ꂩ
				if (!and_sw) { ret = true; break; }
			}
			else {
				//SĂ
				if (and_sw) { ret = false; break; }
			}
		}
		else {
			//܂܂Ȃ
			if (p==0) {
				//ꂩ
				if (!and_sw) { ret = true; break; }
			}
			else {
				//SĂ
				if (and_sw) { ret = false; break; }
			}
		}
	}

	return ret;
}

//---------------------------------------------------------------------------
//̕A}b`̃Xg擾
//---------------------------------------------------------------------------
bool find_mlt_str(
	UnicodeString wd,	// (̏ꍇ͔p܂͑Sp󔒂ŋ؂j
	UnicodeString s,	//Ώە
	TStringList *lst,	//[o] ۂɃ}b`̃Xg
	bool case_sw)		//召	(default = false)
{
	lst->Clear();
	if (wd.IsEmpty()) return false;

	//ꃊXg쐬
	std::unique_ptr<TStringList> wlst(new TStringList());
	get_find_wd_list(wd, wlst.get());

	//
	for (int i=0; i<wlst->Count; i++) {
		UnicodeString wd = wlst->Strings[i];
		int p = case_sw? s.Pos(wd) : pos_i(wd, s);
		if (p>0) {
			UnicodeString fwd = s.SubString(p, wd.Length());
			if (lst->IndexOf(fwd)==-1) lst->Add(fwd);
		}
	}

	return (lst->Count>0);
}

//---------------------------------------------------------------------------
//s擾
//---------------------------------------------------------------------------
int get_line_count(UnicodeString s)
{
	std::unique_ptr<TStringList> lst(new TStringList());
	lst->Text = s;
	return lst->Count;
}

//---------------------------------------------------------------------------
//TStringDynArray ɕǉ
//---------------------------------------------------------------------------
void add_dyn_array(TStringDynArray &lst, UnicodeString s)
{
	int len    = lst.Length;
	lst.Length = len + 1;
	lst[len]   = s;
}

//---------------------------------------------------------------------------
//CSVړe擾
//---------------------------------------------------------------------------
TStringDynArray get_csv_array(UnicodeString src, int size, 
	bool force_size)	//TCYIɐݒ  (default = false)
{
	TStringDynArray ret_array;
	ret_array.Length = size;
	std::unique_ptr<TStringList> rec(new TStringList());
	rec->Delimiter		 = ',';
	rec->QuoteChar		 = '\"';
	rec->StrictDelimiter = true;
	rec->DelimitedText	 = src;
	for (int i=0; i<rec->Count && i<size; i++) ret_array[i] = rec->Strings[i];
	if (!force_size) ret_array.Length = rec->Count;
	return ret_array;
}
//---------------------------------------------------------------------------
UnicodeString get_csv_item(UnicodeString src, int idx)
{
	std::unique_ptr<TStringList> rec(new TStringList());
	rec->Delimiter		 = ',';
	rec->QuoteChar		 = '\"';
	rec->StrictDelimiter = true;
	rec->DelimitedText	 = src;
	return (idx<rec->Count)? rec->Strings[idx] : EmptyStr;
}

//---------------------------------------------------------------------------
//CSVڂ쐬
//---------------------------------------------------------------------------
UnicodeString make_csv_str(UnicodeString s)
{
	return UnicodeString().sprintf(_T("\"%s\""), REPLACE_TS(s, "\"", "\"\"").c_str());
}
//---------------------------------------------------------------------------
UnicodeString make_csv_str(bool sw)
{
	return UnicodeString().sprintf(_T("\"%u\""), sw? 1 : 0);
}

//---------------------------------------------------------------------------
UnicodeString make_csv_rec_str(TStringDynArray lst)
{
	UnicodeString lbuf;
	for (int i=0; i<lst.Length; i++) {
		if (i>0) lbuf.UCAT_T(",");
		lbuf += make_csv_str(lst[i]);
	}
	return lbuf;
}

//---------------------------------------------------------------------------
//CSṼXg p Ԗڂ̍ڂ s ̃CfbNX擾
//---------------------------------------------------------------------------
int indexof_csv_list(TStringList *lst, UnicodeString s, int p)
{
	int idx = -1;
	for (int i=0; i<lst->Count && idx==-1; i++)
		if (SameText(s, get_csv_item(lst->Strings[i], p))) idx = i;
	return idx;
}
//---------------------------------------------------------------------------
//CSṼXg p Ԗڂ̍ڂ s ̃R[h擾
//---------------------------------------------------------------------------
TStringDynArray record_of_csv_list(TStringList *lst, UnicodeString s, int p, int size)
{
	TStringDynArray ret_array;
	if (lst) {
		int idx = indexof_csv_list(lst, s, p);
		if (idx!=-1) ret_array = get_csv_array(lst->Strings[idx], size, true);
	}
	return ret_array;
}

//---------------------------------------------------------------------------
//GXP[vV[PX̕ϊ
//---------------------------------------------------------------------------
UnicodeString conv_esc_char(UnicodeString s)
{
	if (s.IsEmpty()) return EmptyStr;

	s = REPLACE_TS(s, "\\\\", "\f");	//\\ ꎞI \f ɕςĂ
	s = REPLACE_TS(s, "\\t",  "\t");	//^u
	s = REPLACE_TS(s, "\\n",  "\r\n");	//s
	s = REPLACE_TS(s, "\\s",  " ");		//NyanFi ŗL
	s = REPLACE_TS(s, "\f",   "\\");	//\\(\f)  \ ɕϊ
	return s;
}

//---------------------------------------------------------------------------
//u \\  /
//---------------------------------------------------------------------------
UnicodeString yen_to_slash(UnicodeString s)
{
	return REPLACE_TS(s, "\\", "/");
}
//---------------------------------------------------------------------------
//u /  \\
//---------------------------------------------------------------------------
UnicodeString slash_to_yen(UnicodeString s)
{
	return REPLACE_TS(s, "/", "\\");
}

//---------------------------------------------------------------------------
//召ʂɔr
//---------------------------------------------------------------------------
bool same_ut_i(UnicodeString s, _TCHAR *t)
{
	return (_tcsicmp(s.c_str(), t)==0);
}
//---------------------------------------------------------------------------
//召ʂĂɔr
//---------------------------------------------------------------------------
bool same_ut_s(UnicodeString s, _TCHAR *t)
{
	return (_tcscmp(s.c_str(), t)==0);
}

//---------------------------------------------------------------------------
//=="1" ?
//---------------------------------------------------------------------------
bool equal_1(UnicodeString s)
{
	return (_tcscmp(s.c_str(), _T("1"))==0);
}
//---------------------------------------------------------------------------
//=="0" ?
//---------------------------------------------------------------------------
bool equal_0(UnicodeString s)
{
	return (_tcscmp(s.c_str(), _T("0"))==0);
}
//---------------------------------------------------------------------------
//=="ENTER" ?
//---------------------------------------------------------------------------
bool equal_ENTER(UnicodeString s)
{
	return (_tcsicmp(s.c_str(), _T("ENTER"))==0);
}
//---------------------------------------------------------------------------
//=="ESC" ?
//---------------------------------------------------------------------------
bool equal_ESC(UnicodeString s)
{
	return (_tcsicmp(s.c_str(), _T("ESC"))==0);
}
//---------------------------------------------------------------------------
//=="DEL" ?
//---------------------------------------------------------------------------
bool equal_DEL(UnicodeString s)
{
	return (_tcsicmp(s.c_str(), _T("DEL"))==0);
}
//---------------------------------------------------------------------------
//=="LEFT" ?
//---------------------------------------------------------------------------
bool equal_LEFT(UnicodeString s)
{
	return (_tcsicmp(s.c_str(), _T("LEFT"))==0);
}
//---------------------------------------------------------------------------
//=="RIGHT" ?
//---------------------------------------------------------------------------
bool equal_RIGHT(UnicodeString s)
{
	return (_tcsicmp(s.c_str(), _T("RIGHT"))==0);
}
//---------------------------------------------------------------------------
//=="RIGHT" ?
//---------------------------------------------------------------------------
bool equal_F1(UnicodeString s)
{
	return (_tcsicmp(s.c_str(), _T("F1"))==0);
}

//---------------------------------------------------------------------------
//Zp[^(=="-") ?
//---------------------------------------------------------------------------
bool is_separator(UnicodeString s)
{
	return (_tcscmp(s.c_str(), _T("-"))==0);
}

//---------------------------------------------------------------------------
bool starts_t_i(_TCHAR *w, UnicodeString s)
{
	return StartsText(w, s);
}
//---------------------------------------------------------------------------
bool starts_t_s(_TCHAR *w, UnicodeString s)
{
	return StartsStr(w, s);
}
//---------------------------------------------------------------------------
bool starts_t_s(WideChar w, UnicodeString s)
{
	return StartsStr(w, s);
}

//---------------------------------------------------------------------------
bool ends_t_i(_TCHAR *w, UnicodeString s)
{
	return EndsText(w, s);
}
//---------------------------------------------------------------------------
bool ends_t_s(_TCHAR *w, UnicodeString s)
{
	return EndsStr(w, s);
}
//---------------------------------------------------------------------------
bool ends_t_s(WideChar w, UnicodeString s)
{
	return EndsStr(w, s);
}

//---------------------------------------------------------------------------
bool starts_tchs(_TCHAR *lst, UnicodeString s)
{
	return s.IsDelimiter(lst, 1);
}
//---------------------------------------------------------------------------
bool ends_tchs(_TCHAR *lst, UnicodeString s)
{
	return s.IsDelimiter(lst, s.Length());
}

//---------------------------------------------------------------------------
// @ Ŏn܂邩 ?
//---------------------------------------------------------------------------
bool starts_AT(UnicodeString s)
{
	return starts_t_s('@', s);
}
//---------------------------------------------------------------------------
// $ Ŏn܂邩 ?
//---------------------------------------------------------------------------
bool starts_Dollar(UnicodeString s)
{
	return starts_t_s('$', s);
}

//---------------------------------------------------------------------------
// \ ŏI ?
//---------------------------------------------------------------------------
bool ends_PathDlmtr(UnicodeString s)
{
	return ends_t_s('\\', s);
}
//---------------------------------------------------------------------------
// \ ܂ ?
//---------------------------------------------------------------------------
bool contains_PathDlmtr(UnicodeString s)
{
	return contains_s(s, '\\');
}
//---------------------------------------------------------------------------
// / ܂ ?
//---------------------------------------------------------------------------
bool contains_Slash(UnicodeString s)
{
	return contains_s(s, '/');
}

//---------------------------------------------------------------------------
// /`/ (K\) ?
//---------------------------------------------------------------------------
bool is_regex_slash(UnicodeString s)
{
	return (s.Length()>=2 && starts_t_s('/', s) && ends_t_s('/', s));
}

//---------------------------------------------------------------------------
//pň͂܂Ă邩?
//---------------------------------------------------------------------------
bool is_quot(UnicodeString s)
{
	return (s.Length()>=2 && (starts_t_s('\"', s) && ends_t_s('\"', s) || starts_t_s('\'', s) && ends_t_s('\'', s)));
}
//---------------------------------------------------------------------------
//󔒂܂łꍇApň͂
//---------------------------------------------------------------------------
UnicodeString add_quot_if_spc(UnicodeString s)
{
	if (ContainsStr(s, " ") || ContainsStr(s, "@")) s = "\"" + s + "\"";
	return s;
}

//---------------------------------------------------------------------------
//pO
//---------------------------------------------------------------------------
UnicodeString exclude_quot(UnicodeString s)
{
	if (is_quot(s)) s = exclude_top_end(s);
	return s;
}

//---------------------------------------------------------------------------
//TStringList Vlues[name] ̐l擾
//---------------------------------------------------------------------------
int get_ListIntVal(TStringList *lst, _TCHAR *name, int def)
{
	return lst->Values[name].ToIntDef(def);
}
//---------------------------------------------------------------------------
//TStringList Vlues[name] ?
//---------------------------------------------------------------------------
bool ListVal_is_empty(TStringList *lst, _TCHAR *name)
{
	return lst->Values[name].IsEmpty();
}
//---------------------------------------------------------------------------
//TStringList Vlues[name]=="1"?
//---------------------------------------------------------------------------
bool ListVal_equal_1(TStringList *lst, _TCHAR *name)
{
	return (_tcscmp(lst->Values[name].c_str(), _T("1"))==0);
}

//---------------------------------------------------------------------------
//mb玞ԕ
//---------------------------------------------------------------------------
UnicodeString __fastcall mSecToTStr(
	unsigned int ms,
	bool cs)			//1/100b\ (default = true)
{
	int scnt = ms/1000;	//b
	int c = (int)(ms/10.0 + 0.5) % 100;
	int s = scnt % 60;	scnt /= 60;
	int m = scnt % 60;
	int h = scnt / 60;

	UnicodeString ret_str;
	if (cs)
		ret_str.sprintf(_T("%02u:%02u:%02u.%02u"), h, m, s, c);
	else {
		if (c>50) s++;
		ret_str.sprintf(_T("%02u:%02u:%02u"), h, m, s);
	}
	return ret_str;
}
//---------------------------------------------------------------------------
//p[^mbɕϊ
//---------------------------------------------------------------------------
int param_to_mSec(UnicodeString prm)
{
	int k;
	if		(remove_end_text(prm, "S")) k = 1000;
	else if (remove_end_text(prm, "M")) k = (60*1000);
	else if (remove_end_text(prm, "H")) k = (60*60*1000);
	else								k = 1;
	return prm.ToIntDef(0) * k;
}

//---------------------------------------------------------------------------
//w蕶̕\擾
//---------------------------------------------------------------------------
int get_CharWidth(
	TCanvas *cv,
	int n,			//	(pP)
	int mgn)		//]T		(default = 0);
{
	TEXTMETRIC tm;
	::GetTextMetrics(cv->Handle , &tm);
	return (tm.tmAveCharWidth * n + mgn);
}

//---------------------------------------------------------------------------
//  TPanel ̕ςɎ܂悤ɁAwʒu󔒂}
//---------------------------------------------------------------------------
UnicodeString fit_StrToPanel(UnicodeString s, int p, TPanel *pp)
{
	HDC hDc = ::GetDC(pp->Handle);
	if (hDc) {
		std::unique_ptr<TCanvas> cv(new TCanvas());
		cv->Handle = hDc;
		cv->Font->Assign(pp->Font);
		while (cv->TextWidth(UAPP_T(s, "  "))<pp->ClientWidth) s.Insert(" ", p);
		::ReleaseDC(pp->Handle, hDc);
	}
	return s;
}

//---------------------------------------------------------------------------
//pZ̕񒷂擾
//---------------------------------------------------------------------------
int str_len_half(UnicodeString s)
{
	AnsiString    s_a = s;
	UnicodeString s_u = s_a;
	if (s!=s_u && s.Length()==s_u.Length()) {
		UnicodeString r_u;
		for (int i=1; i<=s.Length(); i++) {
			if (!s.IsTrailSurrogate(i)) {
				if (s[i]!=s_u[i] && s_u[i]=='?')
					r_u.UCAT_T("H");
				else
					r_u += s_u[i];
			}
		}
		s_a = r_u;
	}
	return s_a.Length();
}

//---------------------------------------------------------------------------
//TQ[gyAlĕ擾
//---------------------------------------------------------------------------
int str_len_unicode(UnicodeString s)
{
	int n = 0;
	for (int i=1; i<=s.Length(); i++) if (!s.IsTrailSurrogate(i)) n++;
	return n;
}

//---------------------------------------------------------------------------
//ő啝XV
//---------------------------------------------------------------------------
void max_len_half(int &w, UnicodeString s)
{
	w = std::max(w, str_len_half(s));
}

//---------------------------------------------------------------------------
//w蕝(pP)ŕ񂪉ElɂȂ悤ɋ󔒂}
//---------------------------------------------------------------------------
UnicodeString align_r_str(UnicodeString s, int wd, UnicodeString post_s)
{
	int n = str_len_half(s);
	if (n<wd) s.Insert(StringOfChar(_T(' '), wd - n), 1);
	return s + post_s;
}
//---------------------------------------------------------------------------
//w蕝(pP)ŕ񂪍lɂȂ悤ɋ󔒂}
//---------------------------------------------------------------------------
UnicodeString align_l_str(UnicodeString s, int wd, UnicodeString post_s)
{
	int n = str_len_half(s);
	if (n<wd) s += StringOfChar(_T(' '), wd - n);
	return s + post_s;
}

//---------------------------------------------------------------------------
//񂪎w蕝Ɏ܂悤ɒ
//---------------------------------------------------------------------------
UnicodeString minimize_str(
	UnicodeString s,	//Ώە
	TCanvas *cv,
	int  wd,			//
	bool omit_end)		//ȗ (default = false : Ԃȗ)
{
	if (cv->TextWidth(s) > wd) {
		if (omit_end) {
			s.UCAT_T("c");
			int p = s.Length() - 1;
			while (p>0) {
				s.Delete(p--, 1);
				if (cv->TextWidth(s)<=wd) break;
			}
		}
		else {
			int p = 0;
			for (int i=1; i<s.Length(); i++) {
				if (cv->TextWidth(s.SubString(1, i)) > wd/2) {
					p = i - 1; break;
				}
			}
			if (p==0) p = 1;
			s.Insert("c", p);	p += 1;
			while (s.Length()>=p) {
				s.Delete(p, 1);
				if (cv->TextWidth(s)<=wd) break;
			}
		}
	}
	return s;
}

//---------------------------------------------------------------------------
//Sp/pϊ
//---------------------------------------------------------------------------
UnicodeString to_Full_or_Half(UnicodeString s, bool to_w)
{
	const int size_s = s.Length() + 1;
	int size_d = ::LCMapString(::GetUserDefaultLCID(), (to_w? LCMAP_FULLWIDTH : LCMAP_HALFWIDTH), s.c_str(), size_s, NULL, 0);
	std::unique_ptr<_TCHAR[]> sbuf(new _TCHAR[size_d]);
	::ZeroMemory(sbuf.get(), size_d * sizeof(_TCHAR));
	::LCMapString(::GetUserDefaultLCID(), (to_w? LCMAP_FULLWIDTH : LCMAP_HALFWIDTH), s.c_str(), size_s, sbuf.get(), size_d);
	return UnicodeString(sbuf.get());
}
//---------------------------------------------------------------------------
//Spɕϊ
//---------------------------------------------------------------------------
UnicodeString to_FullWidth(UnicodeString s)
{
	return to_Full_or_Half(s, true);
}
//---------------------------------------------------------------------------
//pɕϊ
//---------------------------------------------------------------------------
UnicodeString to_HalfWidth(UnicodeString s)
{
	return to_Full_or_Half(s, false);
}

//---------------------------------------------------------------------------
//rsH
//---------------------------------------------------------------------------
int is_RuledLine(UnicodeString s)
{
	return SameStr(s, StringOfChar(_T(''), s.Length())) ? 1 :
			(SameStr(s, StringOfChar(_T(''), s.Length()))? 2 : 0);
}

//---------------------------------------------------------------------------
//rs擾 (---- -------- ...)
//---------------------------------------------------------------------------
UnicodeString make_RuledLine(int cnt, ...)
{
	UnicodeString ret_str;

	va_list ap;
	va_start(ap, cnt);
	for (int i=0; i<cnt; i++) {
		int w = va_arg(ap, int);
		if (w>0) {
			if (!ret_str.IsEmpty()) ret_str.UCAT_T(" ");
			ret_str += StringOfChar(_T('-'), w);
		}
	}
	va_end(ap);

	return ret_str;
}

//---------------------------------------------------------------------------
//AhX擾
//---------------------------------------------------------------------------
UnicodeString get_AddrStr(__int64 adr,
	int w)		//\ (default = 0)
{
	UnicodeString ret_str;
	if (adr>=0) {
		unsigned int adr_l = adr & 0xffffffffLL;
		int adr_h = adr >> 32;
		ret_str.sprintf(_T("%08X"), adr_l);
		ret_str.Insert(":", 5);
		if (adr_h>0) ret_str = IntToHex(adr_h, 1) + ":" + ret_str;
		ret_str = align_r_str(ret_str, w);
	}
	else
		ret_str.USET_T("____:____");
	return ret_str;
}

//---------------------------------------------------------------------------
//AXyNg䕶擾
//---------------------------------------------------------------------------
UnicodeString get_AspectStr(int w, int h)
{
	if (w==0 || h==0) return EmptyStr;

	int w1 = w;
	int h1 = h;
	if (h1>w1) std::swap(w1, h1);
	for (;;) {
		int r = w1%h1;
		if (r==0) break;
		w1 = h1; h1 = r;
	}
	w /= h1;
	h /= h1;

	UnicodeString ret_str;
	if (w<20)
		ret_str.cat_sprintf(_T("%u : %u"), w, h);
	else {
		if (w>h)
			ret_str.cat_sprintf(_T("%5.4g : 1"), 1.0 * w/h);
		else
			ret_str.cat_sprintf(_T("1 : %5.4g"), 1.0 * h/w);
	}
	return Trim(ret_str);
}

//---------------------------------------------------------------------------
//{L[{[h?
//---------------------------------------------------------------------------
bool is_JpKeybd()
{
	return (::GetKeyboardType(0)==7);
}

//---------------------------------------------------------------------------
//VtgԂ𕶎
//---------------------------------------------------------------------------
UnicodeString get_ShiftStr(TShiftState Shift)
{
	UnicodeString sftstr;
	if (Shift.Contains(ssShift)) sftstr += KeyStr_Shift;
	if (Shift.Contains(ssCtrl))  sftstr += KeyStr_Ctrl;
	if (Shift.Contains(ssAlt))   sftstr += KeyStr_Alt;
	return  sftstr;
}
//---------------------------------------------------------------------------
//L[𕶎
//---------------------------------------------------------------------------
UnicodeString get_KeyStr(WORD Key)
{
	UnicodeString keystr;

	switch (Key) {
	case VK_RETURN: 	keystr.USET_T("ENTER");	break;
	case VK_ESCAPE: 	keystr.USET_T("ESC");	break;
	case VK_PAUSE:  	keystr.USET_T("PAUSE");	break;
	case VK_SPACE:  	keystr.USET_T("SPACE");	break;
	case VK_TAB:		keystr.USET_T("TAB");	break;
	case VK_LEFT:   	keystr.USET_T("LEFT");	break;
	case VK_RIGHT:  	keystr.USET_T("RIGHT");	break;
	case VK_DOWN:		keystr.USET_T("DOWN");	break;
	case VK_UP:			keystr.USET_T("UP");	break;
	case VK_PRIOR:		keystr.USET_T("PGUP");	break;
	case VK_NEXT:		keystr.USET_T("PGDN");	break;
	case VK_HOME:		keystr.USET_T("HOME");	break;
	case VK_END:		keystr.USET_T("END");	break;
	case VK_INSERT:		keystr.USET_T("INS");	break;
	case VK_DELETE: 	keystr.USET_T("DEL");	break;
	case VK_BACK: 		keystr.USET_T("BKSP");	break;
	case VK_F1:			keystr.USET_T("F1");	break;
	case VK_F2:			keystr.USET_T("F2");	break;
	case VK_F3:			keystr.USET_T("F3");	break;
	case VK_F4:			keystr.USET_T("F4");	break;
	case VK_F5:			keystr.USET_T("F5");	break;
	case VK_F6:			keystr.USET_T("F6");	break;
	case VK_F7:			keystr.USET_T("F7");	break;
	case VK_F8:			keystr.USET_T("F8");	break;
	case VK_F9:			keystr.USET_T("F9");	break;
	case VK_F10:		keystr.USET_T("F10");	break;
	case VK_F11:		keystr.USET_T("F11");	break;
	case VK_F12:		keystr.USET_T("F12");	break;
	case VK_APPS:		keystr.USET_T("APP");	break;
	case VK_OEM_1:		keystr.sprintf(_T("%s"), is_JpKeybd()? _T(":") : _T(";")); break;
	case VK_OEM_2:		keystr.USET_T("/");		break;
	case VK_OEM_3:		keystr.sprintf(_T("%s"), is_JpKeybd()? _T("@") : _T("`")); break;
	case VK_OEM_4:		keystr.USET_T("[");		break;
	case VK_OEM_5:		keystr.USET_T("\\");	break;
	case VK_OEM_6:		keystr.USET_T("]");		break;
	case VK_OEM_MINUS:  keystr.USET_T("-");		break;
	case VK_OEM_PLUS:   keystr.sprintf(_T("%s"), is_JpKeybd()? _T(";") : _T("")); break;
	case VK_OEM_COMMA:  keystr.USET_T(",");		break;
	case VK_OEM_PERIOD: keystr.USET_T(".");		break;
	case VK_OEM_102:    keystr.USET_T("_");	break;

	case VK_NUMPAD0:	keystr.USET_T("10Key_0");	break;
	case VK_NUMPAD1:	keystr.USET_T("10Key_1");	break;
	case VK_NUMPAD2:	keystr.USET_T("10Key_2");	break;
	case VK_NUMPAD3:	keystr.USET_T("10Key_3");	break;
	case VK_NUMPAD4:	keystr.USET_T("10Key_4");	break;
	case VK_NUMPAD5:	keystr.USET_T("10Key_5");	break;
	case VK_NUMPAD6:	keystr.USET_T("10Key_6");	break;
	case VK_NUMPAD7:	keystr.USET_T("10Key_7");	break;
	case VK_NUMPAD8:	keystr.USET_T("10Key_8");	break;
	case VK_NUMPAD9:	keystr.USET_T("10Key_9");	break;
	case VK_MULTIPLY:	keystr.USET_T("10Key_*");	break;
	case VK_ADD:		keystr.USET_T("10Key_+");	break;
	case VK_SUBTRACT:	keystr.USET_T("10Key_-");	break;
	case VK_DIVIDE:		keystr.USET_T("10Key_/");	break;
	case VK_DECIMAL:	keystr.USET_T("10Key_.");	break;
	case VK_OEM_7:	  	keystr.sprintf(_T("%s"), is_JpKeybd()? _T("^") : _T("'")); break;

	default:
		if (_istalnum(Key)) keystr = (char)Key; else keystr = EmptyStr;
	}

	return  keystr;
}
//---------------------------------------------------------------------------
//L[ƃVtgԂ𕶎
//---------------------------------------------------------------------------
UnicodeString get_KeyStr(WORD Key, TShiftState Shift)
{
	UnicodeString keystr = get_KeyStr(Key);
	return !keystr.IsEmpty()? get_ShiftStr(Shift) + keystr : EmptyStr;
}
//---------------------------------------------------------------------------
